import json
from logger import Logger
from AbstractParser import AbstractParser
from AbstractNextStage import AbstractNextStage
from TemperatureDatabasePreparer import TemperatureDatabasePreparer

class ModbusParser(AbstractParser, AbstractNextStage):
    def __init__(self):
        super(ModbusParser, self).__init__()
        self.topic = "IoT/Measurement/ModbusHub"

    def execute(self, data):
        Logger.log("ModbusParser %s %s" % (type(data), str(data)))

        try:
            j = json.loads(data['payload'])

            if j['metadata']['Slave'] == 'Thermometer':
                vv = []
                v = TemperatureDatabasePreparer({'name':'Fridge', 
                     'temperature':j['data']['t1'], 
                     'timestamp':data['timestamp']})
                vv.append(v)
                v = TemperatureDatabasePreparer({'name':'Freezer', 
                     'temperature':j['data']['t2'], 
                     'timestamp':data['timestamp']})
                vv.append(v)
            self.executeNextStage(vv)
        except Exception, e:
            Logger.log("Exception in ModbusParser, %s" % (str(e)))
